from Products.CMFCore import FSPageTemplate as cmfFSPT
from Products.CMFCore.FSPageTemplate import *
from ZopeAltPageTemplate import ZopePageTemplate, compiler_registry
from Products.CMFCore import utils
import cPickle as pickle
from OFS.SimpleItem import SimpleItem
import Globals, AccessControl

FSPT = FSPageTemplate

class MacroCollection(SimpleItem):
    __allow_access_to_unprotected_subobjects__ = 1
    #security = AccessControl.ClassSecurityInfo()
    #security.declareObjectProtected('View')
    def __getitem__(self, name):
        if self.aq_parent.metal_macros is ZopePageTemplate.metal_macros:
            self.aq_parent._updateFromFS()
        return self.metal_macros[name]
#Globals.InitializeClass(MacroCollection)

class FSPageTemplate(ZopePageTemplate, FSObject, Script):
    "Wrapper for Page Template"
     
    meta_type = 'Alternative Filesystem Page Template'
    _icon = 'misc_/AltPT/fsaltpt.png'
    icon = _icon
    _compiled = None

    manage_options=(
        (
            {'label':'Customize', 'action':'manage_main'},
            {'label':'Test', 'action':''},
            )
        )

    security = ClassSecurityInfo()
    security.declareObjectProtected(View)

    security.declareProtected(ViewManagementScreens, 'manage_main')
    manage_main = FSPT.manage_main

    # Declare security for unprotected PageTemplate methods.
    security.declarePrivate('pt_edit', 'write', 'pt_editForm',
                            'pt_editAction', 'pt_setTitle', 'pt_edit',
                            'pt_expand', 'pt_upload',
                            'pt_changePrefs', 'PUT', 'manage_FTPput',
                            'write', 'manage_historyCopy',
                            'manage_beforeHistoryCopy',
                            'manage_afterHistoryCopy')

    def __init__(self, id, filepath, fullname=None, properties=None):
        FSObject.__init__(self, id, filepath, fullname, properties)
        self.ZBindings_edit(self._default_bindings)
        self.macros = MacroCollection()

    def _createZODBClone(self):
        """Create a ZODB (editable) equivalent of this object."""
        return ZopePageTemplate(self.getId(), self.read())

    def ZCacheable_isCachingEnabled(self):
        return 0

    def _readFile(self, reparse):
        fp = expandpath(self._filepath)
        file = open(fp, 'rb')
        try: data = file.read()
        finally: file.close()
        if reparse:
            self._compiled = repr(compiler_registry)
            self.write(data)

    security.declarePrivate('read')
    def read(self):
        # Tie in on an opportunity to auto-update
        self._updateFromFS()
        return ZopePageTemplate.read(self)

    def paxtree(self):
        'fetch the pax tree from the zodb'
        if self._compiled != repr(compiler_registry):
            self._parsed = None
        self._updateFromFS()
        return ZopePageTemplate.paxtree(self)


Globals.InitializeClass(FSPageTemplate)
#cmfFSPT.FSPageTemplate = FSPageTemplate

registerFileExtension('pt', FSPageTemplate)
registerFileExtension('html', FSPageTemplate)
registerFileExtension('htm', FSPageTemplate)
registerMetaType('Page Template', FSPageTemplate)

def initialize(context):
    utils.registerIcon(FSPageTemplate,
                       'www/fsaltpt.png', globals())
