# tester: handle the tal: and metal: namespaces

from tal_handler import tal_handler, tal_ns
from metal_handler import metal_handler, metal_ns, metal_compilefile, metal_getmacros

if __name__ == '__main__':
    import sys, pax, pax.paxtransform
    zpt_tr_engine = pax.paxtransform.Engine()
    zpt_tr_engine.add_handler(metal_ns, metal_handler)
    zpt_tr_engine.add_handler(tal_ns, tal_handler)
    import DummyEngine
    default = DummyEngine.Default
    class DumbContext:
        def __init__(self, tr_engine, macros=None):
            self.engine = DummyEngine.DummyEngine(macros)
            self.tr_engine = tr_engine
            self.engine.compilefile = metal_compilefile
            self.engine.getmacros = metal_getmacros
    if len(sys.argv) > 1:
        srcfile = open(sys.argv[1])
    else:
        srcfile = sys.stdin
        sys.stderr.write('Reading source from stdin\n')
    source = pax.xml2pax(srcfile.read())
    macros = metal_getmacros(source)
    print pax.XML(zpt_tr_engine.transform(source, DumbContext(zpt_tr_engine, macros)))
